VERSION 5.00
Object = "{CAB249C7-BAC9-4C51-9526-12F29E40C4CE}#2.6#0"; "ExTvw.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   9438
   ClientLeft      =   4532
   ClientTop       =   979
   ClientWidth     =   5742
   LinkTopic       =   "Form1"
   ScaleHeight     =   9438
   ScaleWidth      =   5742
   Begin VB.CommandButton Command 
      Caption         =   "Finish"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   2
      Left            =   1628
      TabIndex        =   3
      Top             =   8932
      Width           =   2563
   End
   Begin VB.CommandButton Command 
      Caption         =   "Jump to Previous Filter Result"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   1
      Left            =   2992
      TabIndex        =   2
      Top             =   8404
      Width           =   2563
   End
   Begin VB.CommandButton Command 
      Caption         =   "Jump to Next Filter Result"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   0
      Left            =   176
      TabIndex        =   1
      Top             =   8404
      Width           =   2563
   End
   Begin ExTvw.ExplorerTreeView ExplorerTreeView1 
      Height          =   8272
      Left            =   88
      TabIndex        =   0
      Top             =   44
      Width           =   5555
      _ExtentX        =   9794
      _ExtentY        =   14590
      Appearance      =   2
      DrivesOnly      =   -1  'True
      FileAttributes  =   63
      FireBeforeInsertItem=   15
      FolderAttributes=   63
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.064
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      HotTracking     =   -1  'True
      IncludedItems   =   15
      Indent          =   19
      ItemHeight      =   19
      LimitEditInput  =   0   'False
      RootPath        =   "Arbeitsplatz"
      SingleExpand    =   2
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
 
'##############################################################
 
' Demo Project for TimoSoft Concerning "Find Filter Results"
' 04.09.2009
'##############################################################

Private ETV As ExplorerTreeView

Option Explicit
 
Private Sub Form_Load()
    
   ' Reference to ExplorerTreeView
   Set ETV = ExplorerTreeView1
    
   ' Set and Apply Filters
   ' For Reasons of Simplicity only
   ' One Single File Filter
   With ETV
      .FileFilters = "*.txt"
      .UseFileFilters = True
      .UseFolderFilters = False
   End With
    
End Sub
 
Private Sub Command_Click(Index As Integer)
    
   Select Case Index
   
      Case 0
         ' Next Filter Result:
         ' Search Downwards for the Next File, Matching Filter Settings,
         ' and Make it the Selected Tree Item
         Next_Filter_Result ETV.SelectedItem
         'Do
         '   DoEvents
         'Loop Until Next_Filter_Result(ETV.SelectedItem)
         ETV.SetFocus
          
      Case 1
         ' Previous Filter Result:
         ' Search Upwards for the Next File, Matching Filter Settings,
         ' and Make it the Selected Tree Item
          
         ' Not Implemented Yet. Idea:
         ' Make a Correct "Next_Filter_Result"-Function/Sub
         ' Working into the Other Direction
         
      Case 2
         ' Finish
         Unload Me
         
   End Select
    
End Sub
 
Private Sub Next_Filter_Result(ByVal hSelection As Long)
  Dim hNext As Long
  Dim l As Long

  With ETV
    hNext = FindNextMatchInSubTree(hSelection)
    If hNext = -1 Then
      ' try parent item's next sibling sub-tree
      hNext = hSelection
      Do
        hNext = .ItemGetParentItem(hNext)
        If hNext = 0 Then hNext = -1     ' special handling for ShowRoot = False
        If hNext <> -1 Then hNext = .ItemGetNextItem(hNext)
        If hNext = -1 Then
          ' we've reached the end of the tree
          Exit Do
        ElseIf ItemMatchesFilters(hNext) Then
          ' we've found a match
          Exit Do
        Else
          l = FindNextMatchInSubTree(hNext)
          If l <> -1 Then
            ' we've found a match
            hNext = l
            Exit Do
          End If
        End If
      Loop
    End If

    If hNext <> -1 Then
      ' we've found a result
      .SelectedItem = hNext
      .ItemEnsureVisible hNext
    End If
  End With
End Sub

' searches the sub-items of hBaseItem *and the sibling items of hBaseItem*
Private Function FindNextMatchInSubTree(hBaseItem As Long) As Long
  Dim hNext As Long
  Dim l As Long

  With ETV
    ' make sure the sub-items have been loaded
    .ItemLoadSubItems hBaseItem
    hNext = .ItemGetFirstSubItem(hBaseItem)
    If hNext = -1 Then
      ' the item does not have any sub-items, so try the next sibling item
      hNext = .ItemGetNextItem(hBaseItem)
    End If
    Do While hNext <> -1
      ' we've found an item to investigate
      If ItemMatchesFilters(hNext) Then
        FindNextMatchInSubTree = hNext
        Exit Function
      End If

      ' this item doesn't match the filters, so investigate its sub-items
      l = FindNextMatchInSubTree(hNext)
      If l <> -1 Then
        ' a result has been found
        FindNextMatchInSubTree = l
        Exit Function
      End If
      ' no result has been found, so try the next sibling item
      hNext = .ItemGetNextItem(hNext)
    Loop
  End With
  FindNextMatchInSubTree = -1
End Function

Private Function ItemMatchesFilters(hItem As Long) As Boolean
  With ETV
    If .ItemIsPartOfFileSystem(hItem) Then
      ' the item is of a type that can be filtered
      If (.ItemIsFile(hItem) And .UseFileFilters) Or (.ItemIsFolder(hItem) And .UseFolderFilters) Then
        ' filters are activated for this item type, so the item must match the filters
        ItemMatchesFilters = True
      End If
    End If
  End With
End Function


'Public Function Next_Filter_Result(ByVal hSelection As Long) As Boolean
'
'   Dim hNext As Long
'
'   ' Find Next Item Matching Folder/File Filter Settings
'   With ETV
'      hNext = .ItemGetFirstSubItem(hSelection)
'      If hNext = -1 Then
'         hNext = .ItemGetNextItem(hSelection)
'      End If
'      Do While hNext <> -1
'         If .ItemIsPartOfFileSystem(hNext) Then
'            .SelectedItem = hNext
'            .ItemEnsureVisible hNext
'            Next_Filter_Result = True
'            Exit Function
'         End If
'         If Next_Filter_Result(hNext) Then
'            Next_Filter_Result = True
'            Exit Function
'         End If
'         hNext = .ItemGetNextItem(hNext)
'      Loop
'   End With
'
'End Function


